from ZenPacks.community.ConstructionKit.BasicDefinition import *
from ZenPacks.community.ConstructionKit.Construct import *

BASE = "zenTerracotta"
VERSION = Version(2, 2, 0)

def getClientCount(ob): return len(ob.terracottaclients())

TerracottaServerDefinition = type('TerracottaServerDefinition', (BasicDefinition,), {
        'version' : VERSION,
        'zenpackbase': BASE,
        'packZProperties' : [('zTerracottaServerPortRange', '9000-10000', 'string'),],
        'component' : 'TerracottaServer',
        'componentData' : {
                          'singular': 'Terracotta Server',
                          'plural': 'Terracotta Servers',
                          'displayed': 'port', # component field in Event Console
                          'primaryKey': 'port',
                          'properties': { 
                                        'server' : addProperty('Server', default='id', switch='-s',override=True, isReference=True,optional='false'),  
                                        'port' : addProperty('Port', default='9520', switch='-p'),
                                        'clients' : addProperty('Clients', default=0, ptype='int'),
                                        'authenticate': addProperty('Authenticate', default=False, ptype='boolean',switch='-a'),
                                        'user' : addProperty('User', default='zJmxUsername',switch='-u',override=True, isReference=True),
                                        'password' : addProperty('Password', default='zJmxPassword', ptype='password', switch='-w',override=True, isReference=True),
                                        },
                          },
        'createDS' : True,
        'cmdFile'  : 'check-terracotta-server.py',
        'datapoints' : ['clients'],
        'componentMethods' : [getClientCount],
        }
)

addDefinitionSelfComponentRelation(TerracottaServerDefinition,
                          'terracottaserver',  ToOne, 'ZenPacks.community.zenTerracotta.TerracottaServer', 'port',
                          'terracottaport',  ToOne, 'Products.ZenModel.IpService', 'port',
                          "IP Service", 'port')

TerracottaClientDefinition = type('TerracottaClientDefinition', (BasicDefinition,), {
        'version' : VERSION,
        'zenpackbase': BASE,
        'component' : 'TerracottaClient',
        'componentData' : {
                          'singular': 'Terracotta Client',
                          'plural': 'Terracotta Clients',
                          'displayed': 'nodeid', # component field in Event Console
                          'primaryKey': 'nodeid',
                          'properties': { 
                                        # Server side      
                                        'server' : addProperty('Server',default='id',override=True, isReference=True), 
                                        'serverport' : addProperty('Server Port',default='9520', optional=False),
                                        'serverauth': addProperty('Server Authenticate', default=False, ptype='boolean'),
                                        'serveruser' : addProperty('Server User',default='zJmxUsername',override=True, isReference=True),
                                        'serverpassword' : addProperty('Server Password', default='zJmxPassword',override=True, isReference=True,ptype='password'),
                                        # Client Side
                                        'node' : addProperty('Node', switch='-s'),  
                                        'nodeip' : addProperty('Node IP', switch='-s'),  
                                        'nodeport' : addProperty('Node Port', default='8686'),
                                        'nodeid' : addProperty('Node ID'),
                                        'nodeauth': addProperty('Node Authenticate', default=False, ptype='boolean'),
                                        'nodeuser' : addProperty('Node User', default='zJmxUsername',override=True, isReference=True),
                                        'nodepassword' : addProperty('Node Password', default='zJmxPassword',override=True, isReference=True,ptype='password'),
                                        'nodeavailable': addProperty('Node Status Available', default=False, ptype='boolean'),
                                        },
                          },

        'componentMethods' : [],
        }
)

addDefinitionDeviceRelation(TerracottaClientDefinition,
                          'terracottaclients', ToMany, 'ZenPacks.community.zenTerracotta.TerracottaClient','nodeip',
                          'terracottadevice',  ToOne, 'Products.ZenModel.Device', 'manageIp',
                          "Zenoss Device")

addDefinitionSelfComponentRelation(TerracottaClientDefinition,
                          'terracottaclients', ToMany, 'ZenPacks.community.zenTerracotta.TerracottaClient','server',
                          'terracottaserver',  ToOne, 'ZenPacks.community.zenTerracotta.TerracottaServer', 'server',
                          "Terracotta Server")

addDefinitionDeviceComponentRelation(TerracottaClientDefinition, 'manageIp', 'nodeip',
                          'terracottaclient', ToOne, 'ZenPacks.community.zenTerracotta.TerracottaClient','nodeport',
                          'terracottajavaapp',  ToOne, 'ZenPacks.community.zenJavaApp.JavaApp', 'port',
                          "Java App")

addDefinitionDeviceComponentRelation(TerracottaClientDefinition,'manageIp', 'nodeip',
                          'terracottaclient', ToOne, 'ZenPacks.community.zenTerracotta.TerracottaClient','nodeport',
                          'ipservice',  ToOne, 'Products.ZenModel.IpService', 'port',
                          'IP Service', 'nodeport')
