
(function(){
    var ZC = Ext.ns('Zenoss.component');

    function render_link(ob) {
        if (ob && ob.uid) {
            return Zenoss.render.link(ob.uid);
        } else {
            return ob;
        }
    }

    ZC.TerracottaClientPanel = Ext.extend(ZC.ComponentGridPanel, {
        constructor: function(config) {
            config = Ext.applyIf(config||{}, {
                componentType: 'TerracottaClient',
                autoExpandColumn: 'name', 
                fields:                 [
                    {
                        "name": "uid"
                    }, 
                    {
                        "name": "severity"
                    }, 
                    {
                        "name": "status"
                    }, 
                    {
                        "name": "name"
                    }, 
                    {
                        "name": "getIpserviceLink"
                    }, 
                    {
                        "name": "getTerracottadeviceLink"
                    }, 
                    {
                        "name": "getTerracottajavaappLink"
                    }, 
                    {
                        "name": "getTerracottaserverLink"
                    }, 
                    {
                        "name": "serverport"
                    }, 
                    {
                        "name": "usesMonitorAttribute"
                    }, 
                    {
                        "name": "monitor"
                    }, 
                    {
                        "name": "monitored"
                    }, 
                    {
                        "name": "locking"
                    }
                ]
,
                columns:                [
                    {
                        "sortable": "true", 
                        "width": 50, 
                        "header": "Events", 
                        "renderer": Zenoss.render.severity, 
                        "id": "severity", 
                        "dataIndex": "severity"
                    }, 
                    {
                        "header": "Name", 
                        "width": 70, 
                        "sortable": "true", 
                        "id": "name", 
                        "dataIndex": "name"
                    }, 
                    {
                        "header": "IP Service", 
                        "width": 120, 
                        "sortable": "true", 
                        "id": "getIpserviceLink", 
                        "dataIndex": "getIpserviceLink"
                    }, 
                    {
                        "header": "Zenoss Device", 
                        "width": 120, 
                        "sortable": "true", 
                        "id": "getTerracottadeviceLink", 
                        "dataIndex": "getTerracottadeviceLink"
                    }, 
                    {
                        "header": "Java App", 
                        "width": 120, 
                        "sortable": "true", 
                        "id": "getTerracottajavaappLink", 
                        "dataIndex": "getTerracottajavaappLink"
                    }, 
                    {
                        "header": "Terracotta Server", 
                        "width": 120, 
                        "sortable": "true", 
                        "id": "getTerracottaserverLink", 
                        "dataIndex": "getTerracottaserverLink"
                    }, 
                    {
                        "header": "Server Port", 
                        "width": 120, 
                        "sortable": "true", 
                        "id": "serverport", 
                        "dataIndex": "serverport"
                    }, 
                    {
                        "header": "Monitored", 
                        "width": 65, 
                        "sortable": "true", 
                        "id": "monitored", 
                        "dataIndex": "monitored"
                    }, 
                    {
                        "sortable": "true", 
                        "width": 65, 
                        "header": "Locking", 
                        "renderer": Zenoss.render.locking_icons, 
                        "id": "locking", 
                        "dataIndex": "locking"
                    }
                ]

            });
            ZC.TerracottaClientPanel.superclass.constructor.call(this, config);
        }
    });
    
    Ext.reg('TerracottaClientPanel', ZC.TerracottaClientPanel);
    ZC.registerName('TerracottaClient', _t('Terracotta Client'), _t('Terracotta Clients'));
    
    })();

